int proceed_dt(BallsType *balls, BordersType *borders, BMfloat dt)
{
    int i;
    int balls_moving=0;
    myvec accel, waccel, uspeed, uspeed_eff, uspeed2, uspeed_eff2,
          fricaccel, fricmom, rollmom, totmom, v_old;

    /* timestep wit actual speeds, omegas,... */
    proceed_dt_euler_new(balls, borders, dt, 0);

    /* calc new accelerations */
    for(i=0;i<balls->nr;i++) if(balls->ball[i].in_game){
        if( vec_abs(balls->ball[i].v)!=0 || vec_abs(balls->ball[i].w)!=0 ){
            balls_moving=1;
        }
        /* calc accel 3D */
//        accel  = vec_scale(vec_unit(balls->ball[i].v),-MU_ROLL*GRAVITY*dt); // rollreibg
        accel  = vec_xyz(0.0,0.0,0.0); // rollreibg
        uspeed = vec_scale( vec_cross(balls->ball[i].w,vec_xyz(0.0,0.0,1.0)),
                            -balls->ball[i].d/2.0 );                  /* r*(ez x omega) */
        uspeed_eff = vec_add(uspeed,balls->ball[i].v);
        if( vec_abs( uspeed_eff ) > SLIDE_THRESH_SPEED ){  /* if sliding */

            if(i==0) fprintf(stderr,"sliding\n");
            fricaccel = vec_scale( vec_unit(uspeed_eff), -MU_SLIDE*GRAVITY );
            accel = vec_add(accel, fricaccel);
            fricmom = vec_scale( vec_cross(fricaccel, vec_xyz(0.0,0.0,-balls->ball[i].d/2.0)), balls->ball[i].m );
            waccel = vec_scale( fricmom,-1.0/balls->ball[i].I );

            balls->ball[i].w = vec_add( balls->ball[i].w, vec_scale(waccel,dt) );
            balls->ball[i].v = vec_add( balls->ball[i].v, vec_scale(accel,dt) );
            uspeed2 = vec_scale( vec_cross(balls->ball[i].w,vec_xyz(0.0,0.0,1.0)),
                                -balls->ball[i].d/2.0 );        /* r*(ez x omega) */
            uspeed_eff2 = vec_add(uspeed2,balls->ball[i].v);
            /* if uspeed_eff passes 0 */
            if( vec_angle(uspeed_eff2,uspeed_eff) > M_PI/2.0 ){
                myvec dummy;
                /* make rolling if uspeed_eff passed 0 */
                dummy = vec_ncomp(vec_xyz(0.0,0.0,-balls->ball[i].d/2.0),balls->ball[i].w);
                balls->ball[i].w = vec_scale(vec_cross(balls->ball[i].v,dummy),
                                             1.0/vec_abssq(dummy));
                if(i==0) fprintf(stderr,"made rolling\n");
            }
            if( vec_abs(balls->ball[i].v) < SLIDE_THRESH_SPEED ){
                balls->ball[i].v = vec_xyz( 0.0, 0.0, 0.0 );
                balls->ball[i].w = vec_xyz( 0.0, 0.0, 0.0 );
            }

        } else {                                             /* rolling forces */

            /*
            fricaccel = vec_scale( vec_unit(uspeed_eff), -MU_SLIDE
                                   *( vec_abs(uspeed_eff) / SLIDE_THRESH_SPEED )
                                   *( vec_abs(uspeed_eff) / SLIDE_THRESH_SPEED )
                                   *GRAVITY );
            accel = vec_add(accel, fricaccel);
            fricmom = vec_scale( vec_cross(fricaccel, vec_xyz(0.0,0.0,-balls->ball[i].d/2.0)), balls->ball[i].m );
            waccel = vec_scale( fricmom,-1.0/balls->ball[i].I );*/
            /* should make a w-v alignment here  */

            if(i==0) fprintf(stderr,"rolling\n");
//            if( fabs(vec_mul(vec_xyz(0.0,0.0,SPOT_R),balls->ball[i].w)) > SLIDE_THRESH_SPEED ){
//            if( fabs(vec_mul(vec_xyz(0.0,0.0,1.0),balls->ball[i].w)) > OMEGA_MIN ){
//                fricmom = vec_add(fricmom,
//                                  vec_scale(
//                                            vec_unit(vec_xyz(0.0,0.0,balls->ball[i].w.z)),
//                                            MU_SLIDE*balls->ball[i].m*GRAVITY*SPOT_R
//                                           )
//                                 );
//            } else {
//            }


//            fricmom = vec_xyz(0.0,0.0,0.0);

            #define ROLL_MOM_R MU_ROLL*balls->ball[i].d/5.0   /* wirkabstand von rollwid.-kraft */
            rollmom = vec_cross(
                                vec_xyz(0.0,0.0,balls->ball[i].m*GRAVITY * ROLL_MOM_R),
                                vec_unit(balls->ball[i].v)
                               );

            totmom = vec_add(fricmom,rollmom);
            waccel = vec_scale( totmom,-1.0/balls->ball[i].I );

            /* align w and v to assure rolling */
            accel = vec_add( accel,
                             vec_scale(
                             vec_cross( vec_scale( rollmom,-1.0/balls->ball[i].I ) ,
                                        vec_xyz(0.0,0.0,-balls->ball[i].d/2.0)
                                      ),-1.0)
                           );

            balls->ball[i].w = vec_add( balls->ball[i].w, vec_scale(waccel,dt) );
            v_old=balls->ball[i].v;
            balls->ball[i].v = vec_add( balls->ball[i].v, vec_scale(accel,dt) );
/*            if( vec_angle(v_old,balls->ball[i].v)>M_PI/2.0 ){
                balls->ball[i].v = vec_xyz( 0.0, 0.0, 0.0 );
                balls->ball[i].w = vec_xyz( 0.0, 0.0, 0.0 );
            }*/
            if( vec_abs(balls->ball[i].v) < SLIDE_THRESH_SPEED ){
                balls->ball[i].v = vec_xyz( 0.0, 0.0, 0.0 );
                balls->ball[i].w = vec_xyz( 0.0, 0.0, 0.0 );
            }
        }
        /* calc waccel 3D */
//        waccel = vec_scale( vec_add(vec_scale(fricmom,+1.0),rollmom),-1.0/balls->ball[i].I*dt);
//        waccel = vec_scale( vec_proj(fricmom,balls->ball[i].w),
//                            -1.0/balls->ball[i].I*dt );
//        waccel = vec_scale( rollmom,-1.0/balls->ball[i].I*dt);
//        waccel = vec_scale(balls->ball[i].w,-0.1*dt); // fix this

        /* w - omega */
//        balls->ball[i].w = vec_add( balls->ball[i].w, vec_scale(waccel,dt) );
//        if( vec_abs(balls->ball[i].w) < OMEGA_MIN )
//            balls->ball[i].w = vec_xyz( 0.0, 0.0, 0.0 );
        /* v - speed */
/*        balls->ball[i].v = vec_add( balls->ball[i].v, vec_scale(accel,dt) );
        if( vec_abs(balls->ball[i].v) < SLIDE_THRESH_SPEED ){
            balls->ball[i].v = vec_xyz( 0.0, 0.0, 0.0 );
            balls->ball[i].w = vec_xyz( 0.0, 0.0, 0.0 );
        }*/
    }

    remove_balls_from_game( balls, borders );

    return balls_moving;
}
